Index: arch/mvme68k/mvme68k/locore.s
===================================================================
RCS file: /cvs/src/sys/arch/mvme68k/mvme68k/locore.s,v
retrieving revision 1.54
diff -u -r1.54 locore.s
--- arch/mvme68k/mvme68k/locore.s	15 May 2007 13:46:22 -0000	1.54
+++ arch/mvme68k/mvme68k/locore.s	25 Sep 2007 09:53:50 -0000
@@ -1165,51 +1165,18 @@
  */
 #include <m68k/m68k/support.s>
 
-/*
- * Use common m68k process manipulation routines.
- */
-#include <m68k/m68k/proc_subr.s>
-
 	.data
 GLOBAL(curpcb)
 	.long	0
 
 ASBSS(nullpcb,SIZEOF_PCB)
 
-/*
- * At exit of a process, do a switch for the last time.
- * Switch to a safe stack and PCB, and deallocate the process's resources.
- */
-ENTRY(switch_exit)
-	movl	sp@(4),a0
-	| save state into garbage pcb
-	movl	#_ASM_LABEL(nullpcb),_C_LABEL(curpcb)
-	lea	_ASM_LABEL(tmpstk),sp	| goto a tmp stack
-
-        /* Schedule the vmspace and stack to be freed. */
-	movl    a0,sp@-                 | exit2(p)
-	jbsr    _C_LABEL(exit2)
-	lea     sp@(4),sp               | pop args
-
-	jra	_C_LABEL(cpu_switch)
-
-/*
- * When no processes are on the runq, Swtch branches to Idle
- * to wait for something to come ready.
- */
-ASENTRY_NOPROFILE(Idle)
+ENTRY_NOPROFILE(cpu_idle_cycle)
 	stop	#PSL_LOWIPL
-	movw	#PSL_HIGHIPL,sr
-	movl	_C_LABEL(whichqs),d0
-	jeq	_ASM_LABEL(Idle)
-	jra	Lsw1
-
-Lbadsw:
-	PANIC("switch")
-	/*NOTREACHED*/
+	rts
 
 /*
- * cpu_switch()
+ * cpu_switchto(struct proc *oldproc, struct proc *newproc)
  *
  * NOTE: On the mc68851 we attempt to avoid flushing the
  * entire ATC.  The effort involved in selective flushing may not be
@@ -1219,55 +1186,15 @@
  * user's PTEs have been changed (formerly denoted by the SPTECHG p_flag
  * bit).  For now, we just always flush the full ATC.
  */
-ENTRY(cpu_switch)
-	movl	_C_LABEL(curpcb),a0	| current pcb
-	movw	sr,a0@(PCB_PS)		| save sr before changing ipl
-#ifdef notyet
-	movl	CURPROC,sp@-		| remember last proc running
-#endif
-	clrl	CURPROC
+ENTRY(cpu_switchto)
+	movl	sp@(4), d0		| oldproc
+	beq	Lswnofpsave		| is NULL, don't save anything
 
 	/*
-	 * Find the highest-priority queue that isn't empty,
-	 * then take the first proc from that queue.
-	 */
-	movw	#PSL_HIGHIPL,sr		| lock out interrupts
-	movl	_C_LABEL(whichqs),d0
-	jeq	_ASM_LABEL(Idle)
-Lsw1:
-	movl	d0,d1
-	negl	d0
-	andl	d1,d0
-	bfffo	d0{#0:#32},d1
-	eorib	#31,d1
-
-	movl	d1,d0
-	lslb	#3,d1			| convert queue number to index
-	addl	#_C_LABEL(qs),d1	| locate queue (q)
-	movl	d1,a1
-	movl	a1@(P_FORW),a0		| p = q->p_forw
-	cmpal	d1,a0			| anyone on queue?
-	jeq	Lbadsw			| no, panic
-	movl	a0@(P_FORW),a1@(P_FORW)	| q->p_forw = p->p_forw
-	movl	a0@(P_FORW),a1		| n = p->p_forw
-	movl	d1,a1@(P_BACK)		| n->p_back = q
-	cmpal	d1,a1			| anyone left on queue?
-	jne	Lsw2			| yes, skip
-	movl	_C_LABEL(whichqs),d1
-	bclr	d0,d1			| no, clear bit
-	movl	d1,_C_LABEL(whichqs)
-Lsw2:
-	movl	a0,CURPROC
-	clrl	_C_LABEL(want_resched)
-#ifdef notyet
-	movl	sp@+,a1
-	cmpl	a0,a1			| switching to same proc?
-	jeq	Lswdone			| yes, skip save and restore
-#endif
-	/*
 	 * Save state of previous process in its pcb.
 	 */
         movl	_C_LABEL(curpcb),a1
+	movw	sr, a1@(PCB_PS)		| save sr before switching context
 	moveml	#0xFCFC,a1@(PCB_REGS)	| save non-scratch registers
 	movl	usp,a2			| grab USP (a2 has been saved)
 	movl	a2,a1@(PCB_USP)		| and save it
@@ -1295,15 +1222,12 @@
 	fmovem	fpsr,a2@(FPF_FPSR)
 	fmovem	fpi,a2@(FPF_FPI)
 #endif /* M68060 */
+
 Lswnofpsave:
-#ifdef DIAGNOSTIC
-	tstl	a0@(P_WCHAN)
-	jne	Lbadsw
-	cmpb	#SRUN,a0@(P_STAT)
-	jne	Lbadsw
-#endif
+	movl	sp@(8), a0		| newproc
+
+	movl	a0, CURPROC
 	movb	#SONPROC,a0@(P_STAT)
-	clrl	a0@(P_BACK)		| clear back link
 	movl	a0@(P_ADDR),a1		| get p_addr
 	movl	a1,_C_LABEL(curpcb)
 
Index: arch/mvme68k/mvme68k/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/mvme68k/mvme68k/vm_machdep.c,v
retrieving revision 1.45
diff -u -r1.45 vm_machdep.c
--- arch/mvme68k/mvme68k/vm_machdep.c	20 Jun 2007 17:29:36 -0000	1.45
+++ arch/mvme68k/mvme68k/vm_machdep.c	25 Sep 2007 09:53:50 -0000
@@ -117,20 +117,18 @@
 
 /*
  * cpu_exit is called as the last action during exit.
- * We release the address space and machine-dependent resources,
- * including the memory for the user structure and kernel stack.
- * Once finished, we call switch_exit, which switches to a temporary
- * pcb and stack and never returns.  We block memory allocation
- * until switch_exit has made things safe again.
+ *
+ * Block context switches and then call switch_exit() which will
+ * switch to another process thus we never return.
  */
 void
 cpu_exit(p)
 	struct proc *p;
 {
+	(void)splhigh();
 
-	splhigh();
-	switch_exit(p);
-	/* NOTREACHED */
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 /*
Index: arch/mvme88k/mvme88k/locore.S
===================================================================
RCS file: /cvs/src/sys/arch/mvme88k/mvme88k/locore.S,v
retrieving revision 1.49
diff -u -r1.49 locore.S
--- arch/mvme88k/mvme88k/locore.S	8 May 2006 14:03:35 -0000	1.49
+++ arch/mvme88k/mvme88k/locore.S	25 Sep 2007 09:53:50 -0000
@@ -346,14 +346,6 @@
 	bsr.n	_C_LABEL(secondary_main)
 	 addu	r31, r3, USIZE			/* switch to idle stack */
 
-	/*
-	 * At this point, the CPU has been correctly initialized and has
-	 * identified itself on the console.
-	 * All it needs now is to jump to the idle loop and wait for work to
-	 * be offered.
-	 */
-	br	_ASM_LABEL(cpu_switch_idle)
-
 #endif	/* MULTIPROCESSOR */
 
 /*
Index: arch/mvme88k/mvme88k/machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/mvme88k/mvme88k/machdep.c,v
retrieving revision 1.192
diff -u -r1.192 machdep.c
--- arch/mvme88k/mvme88k/machdep.c	6 Jun 2007 17:15:12 -0000	1.192
+++ arch/mvme88k/mvme88k/machdep.c	25 Sep 2007 09:53:51 -0000
@@ -719,19 +719,18 @@
 secondary_main()
 {
 	struct cpu_info *ci = curcpu();
+	int s;
 
 	cpu_configuration_print(0);
+	sched_init_cpu(ci);
 	ncpus++;
 	__cpu_simple_unlock(&cpu_mutex);
 
 	microuptime(&ci->ci_schedstate.spc_runtime);
 	ci->ci_curproc = NULL;
 
-	/*
-	 * Upon return, the secondary cpu bootstrap code in locore will
-	 * enter the idle loop, waiting for some food to process on this
-	 * processor.
-	 */
+	SCHED_LOCK(s);
+	cpu_switchto(NULL, sched_chooseproc());
 }
 
 #endif	/* MULTIPROCESSOR */
Index: arch/powerpc/conf/files.powerpc
===================================================================
RCS file: /cvs/src/sys/arch/powerpc/conf/files.powerpc,v
retrieving revision 1.42
diff -u -r1.42 files.powerpc
--- arch/powerpc/conf/files.powerpc	22 Mar 2007 19:26:27 -0000	1.42
+++ arch/powerpc/conf/files.powerpc	25 Sep 2007 09:53:51 -0000
@@ -2,7 +2,6 @@
 #
 
 file	arch/powerpc/powerpc/setjmp.S			ddb
-file	arch/powerpc/powerpc/Locore.c
 file	arch/powerpc/powerpc/bcopy.c
 file	arch/powerpc/powerpc/copystr.c
 file	arch/powerpc/powerpc/cpu_subr.c
Index: arch/powerpc/include/pcb.h
===================================================================
RCS file: /cvs/src/sys/arch/powerpc/include/pcb.h,v
retrieving revision 1.10
diff -u -r1.10 pcb.h
--- arch/powerpc/include/pcb.h	20 Mar 2007 20:59:53 -0000	1.10
+++ arch/powerpc/include/pcb.h	25 Sep 2007 09:53:51 -0000
@@ -49,7 +49,6 @@
 	struct pmap *pcb_pm;	/* pmap of our vmspace */
 	struct pmap *pcb_pmreal; /* real address of above */
 	register_t pcb_sp;	/* saved SP */
-	int pcb_spl;		/* saved SPL */
 	faultbuf *pcb_onfault;	/* For use during copyin/copyout */
 	int pcb_flags;
 #define	PCB_FPU		1	/* Process had FPU initialized */
Index: arch/powerpc/powerpc/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/powerpc/powerpc/vm_machdep.c,v
retrieving revision 1.44
diff -u -r1.44 vm_machdep.c
--- arch/powerpc/powerpc/vm_machdep.c	20 Jun 2007 17:29:36 -0000	1.44
+++ arch/powerpc/powerpc/vm_machdep.c	25 Sep 2007 09:53:51 -0000
@@ -123,7 +123,6 @@
 	sf->sp = (int)cf;
 	sf->user_sr = pmap_kernel()->pm_sr[PPC_USER_SR]; /* just in case */
 	pcb->pcb_sp = (int)stktop2;
-	pcb->pcb_spl = 0;
 }
 
 /*
@@ -155,8 +154,8 @@
 		pool_put(&ppc_vecpl, pcb->pcb_vr);
 #endif /* ALTIVEC */
 	
-	(void)splsched();
-	switchexit(p);
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 /*
Index: arch/sgi/localbus/macebus.c
===================================================================
RCS file: /cvs/src/sys/arch/sgi/localbus/macebus.c,v
retrieving revision 1.26
diff -u -r1.26 macebus.c
--- arch/sgi/localbus/macebus.c	9 Jul 2007 21:40:24 -0000	1.26
+++ arch/sgi/localbus/macebus.c	25 Sep 2007 09:53:52 -0000
@@ -780,7 +780,6 @@
 intrmask_t
 macebus_aux(intrmask_t hwpend, struct trap_frame *cf)
 {
-	extern char idle[], e_idle[];
 	u_int64_t mask;
 
 	mask = bus_space_read_8(&macebus_tag, mace_h, MACE_ISA_MISC_REG);
@@ -791,7 +790,8 @@
 	/* RED   - User Mode */
 	if (cf->sr & SR_KSU_USER) {
 		mask &= ~MACE_ISA_MISC_RLED_OFF;
-	} else if (cf->pc >= (long)idle && cf->pc < (long)e_idle) {
+	} else if (curproc == NULL ||
+	    curproc == curcpu()->ci_schedstate.spc_idleproc) {
 		mask &= ~MACE_ISA_MISC_GLED_OFF;	
 	} else {
 		mask &= ~(MACE_ISA_MISC_RLED_OFF | MACE_ISA_MISC_GLED_OFF);
Index: arch/sgi/sgi/genassym.cf
===================================================================
RCS file: /cvs/src/sys/arch/sgi/sgi/genassym.cf,v
retrieving revision 1.9
diff -u -r1.9 genassym.cf
--- arch/sgi/sgi/genassym.cf	18 Jun 2007 20:25:55 -0000	1.9
+++ arch/sgi/sgi/genassym.cf	25 Sep 2007 09:53:52 -0000
@@ -38,9 +38,7 @@
 export	SONPROC
 
 struct	proc
-member	p_forw
-member	p_back
-member	p_priority
+#member	p_priority
 member	p_stat
 member	p_addr
 #member	P_UPTE		p_md.md_upte
Index: arch/sh/include/cpu.h
===================================================================
RCS file: /cvs/src/sys/arch/sh/include/cpu.h,v
retrieving revision 1.10
diff -u -r1.10 cpu.h
--- arch/sh/include/cpu.h	6 Jun 2007 17:15:12 -0000	1.10
+++ arch/sh/include/cpu.h	25 Sep 2007 09:53:52 -0000
@@ -125,6 +125,11 @@
  * We need a machine-independent name for this.
  */
 #define	DELAY(x)		delay(x)
+
+#define	cpu_idle_enter()	do { /* nothing */ } while (0)
+#define	cpu_idle_cycle()	__asm volatile("sleep")
+#define	cpu_idle_leave()	do { /* nothing */ } while (0)
+
 #endif /* _KERNEL */
 
 /*
Index: arch/sh/sh/genassym.cf
===================================================================
RCS file: /cvs/src/sys/arch/sh/sh/genassym.cf,v
retrieving revision 1.3
diff -u -r1.3 genassym.cf
--- arch/sh/sh/genassym.cf	14 May 2007 07:05:49 -0000	1.3
+++ arch/sh/sh/genassym.cf	25 Sep 2007 09:53:52 -0000
@@ -54,8 +54,6 @@
 
 struct	proc
 member	p_addr
-member	p_back
-member	p_forw
 member	p_stat
 member	p_wchan
 member	P_MD_UPTE	p_md.md_upte
Index: arch/sh/sh/locore_c.c
===================================================================
RCS file: /cvs/src/sys/arch/sh/sh/locore_c.c,v
retrieving revision 1.5
diff -u -r1.5 locore_c.c
--- arch/sh/sh/locore_c.c	9 Sep 2007 11:57:55 -0000	1.5
+++ arch/sh/sh/locore_c.c	25 Sep 2007 09:53:52 -0000
@@ -127,26 +127,14 @@
 #include <sh/ubcreg.h>
 
 void (*__sh_switch_resume)(struct proc *);
-struct proc *cpu_switch_search(struct proc *);
-struct proc *cpu_switch_prepare(struct proc *, struct proc *);
-void switch_exit(struct proc *, void (*)(struct proc *));
-void idle(void);
+void cpu_switch_prepare(struct proc *, struct proc *);
 int want_resched;
 
-#ifdef LOCKDEBUG
-#define	SCHED_LOCK_IDLE()	sched_lock_idle()
-#define	SCHED_UNLOCK_IDLE()	sched_unlock_idle()
-#else
-#define	SCHED_LOCK_IDLE()	do {} while (/* CONSTCOND */ 0)
-#define	SCHED_UNLOCK_IDLE()	do {} while (/* CONSTCOND */ 0)
-#endif
-
-
 /*
  * Prepare context switch from oproc to nproc.
- * This code is shared by cpu_switch and cpu_switchto.
+ * This code is used by cpu_switchto.
  */
-struct proc *
+void
 cpu_switch_prepare(struct proc *oproc, struct proc *nproc)
 {
 	nproc->p_stat = SONPROC;
@@ -154,10 +142,8 @@
 	if (oproc && (oproc->p_md.md_flags & MDP_STEP))
 		_reg_write_2(SH_(BBRB), 0);
 
-	if (nproc != oproc) {
-		curpcb = nproc->p_md.md_pcb;
-		pmap_activate(nproc);
-	}
+	curpcb = nproc->p_md.md_pcb;
+	pmap_activate(nproc);
 
 	if (nproc->p_md.md_flags & MDP_STEP) {
 		int pm_asid = nproc->p_vmspace->vm_map.pmap->pm_asid;
@@ -171,34 +157,6 @@
 	}
 
 	curproc = nproc;
-	return (nproc);
-}
-
-/*
- * Find the highest priority proc and prepare to switching to it.
- */
-struct proc *
-cpu_switch_search(struct proc *oproc)
-{
-	struct prochd *q;
-	struct proc *p;
-
-	curproc = NULL;
-
-	SCHED_LOCK_IDLE();
-	while (sched_is_idle()) {
-		SCHED_UNLOCK_IDLE();
-		idle();
-		SCHED_LOCK_IDLE();
-	}
-
-	q = &qs[ffs(whichqs) - 1];
-	p = q->ph_link;
-	remrunqueue(p);
-	want_resched = 0;
-	SCHED_UNLOCK_IDLE();
-
-	return (cpu_switch_prepare(oproc, p));
 }
 
 void
@@ -207,24 +165,8 @@
 	if (p->p_md.md_flags & MDP_STEP)
 		_reg_write_2(SH_(BBRB), 0);
 
-	switch_exit(p, exit2);
-}
-
-/*
- * void idle(void):
- *	When no processes are on the run queue, wait for something to come
- *	ready. Separated function for profiling.
- */
-void
-idle()
-{
-	spl0();
-#if 0
-	if (uvm.page_idle_zero)
-		uvm_pageidlezero();
-#endif
-	__asm volatile("sleep");
-	splsched();
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 #ifndef P1_STACK
Index: arch/sh/sh/locore_subr.S
===================================================================
RCS file: /cvs/src/sys/arch/sh/sh/locore_subr.S,v
retrieving revision 1.6
diff -u -r1.6 locore_subr.S
--- arch/sh/sh/locore_subr.S	2 Mar 2007 06:11:54 -0000	1.6
+++ arch/sh/sh/locore_subr.S	25 Sep 2007 09:53:53 -0000
@@ -180,27 +180,26 @@
 	.text
 	.align 5	/* align cache line size (32B) */
 /*
- * LINTSTUB: Func: void cpu_switch(struct proc *p, struct proc *XXX_IGNORED)
- *	Find a runnable proc and switch to it.  Wait if necessary.
+ * LINTSTUB: Func: void cpu_switchto(struct proc *old, struct proc *new)
+ *	Switch proc contexts.
  */
-ENTRY(cpu_switch)
-	/* Save current proc's context to switchframe */
+ENTRY(cpu_switchto)
+	mov	r4,	r0
+	cmp/eq	#0,	r0
+	bt	1f
+
+	/* Save old proc's context to switchframe */
 	mov.l	.L_SF,	r0
 	mov.l	@(r0, r4), r1
 	SAVEPCB(r1)
 	add	#PCB_FP, r1
 	SAVEFP(r1, r8, r9)
 
-.L_find_and_switch:
-	/* Search next proc. cpu_switch_search may or may not sleep. */
-	mov.l	.L_cpu_switch_search, r0
+1:
+	mov.l	.L_cpu_switch_prepare, r0
 	jsr	@r0
-	 mov	r4,	r8	/* save old proc */
-
-	/* Skip context switch if same proc. */
-	cmp/eq	r8,	r0
-	bt/s	1f
-	 mov	r0,	r4	/* new proc */
+	 mov	r5,	r8	/* save new proc */
+	mov	r8,	r4
 
 	/* Setup kernel stack */
 	mov.l	.L_SF,	r0
@@ -224,7 +223,7 @@
 	/* Now OK to use kernel stack. */
 
 	/* Restore new proc's context from switchframe */
-1:	mov.l	.L_SF,	r0
+	mov.l	.L_SF,	r0
 	mov.l	@(r0, r4), r1
 	add	#4,	r1		/* r15 already restored */
 	mov.l	@r1+,	r14
@@ -248,48 +247,8 @@
 	 nop
 	.align	2
 .L_SF:			.long	(P_MD_PCB)
-.L_cpu_switch_search:	.long	_C_LABEL(cpu_switch_search)
+.L_cpu_switch_prepare:	.long	_C_LABEL(cpu_switch_prepare)
 FUNC_SYMBOL(switch_resume)
-
-
-/*
- * LINTSTUB: Func: void switch_exit(struct proc *p, void (*exit_func)(struct proc *))
- *	Called only from cpu_exit(p).  Before we call exit_func to
- *	free proc's resources (including kernel stack) we need to
- *	switch to the proc0's kernel stack.  Then we jump into the
- *	middle of cpu_switch to find and switch to a new proc.
- */
-ALTENTRY(switch_exit)
-	mov.l	.L_switch_exit_proc0_pcb, r1
-	mov.l	.L_switch_exit_curpcb, r0
-	mov.l	@r1, r1
-	mov.l	r1, @r0			/* curpcb = proc0.p_md.md_pcb */
-
-	mov.l	@(SF_R7_BANK, r1), r0	/* stack top */
-	mov.l	@(SF_R6_BANK, r1), r2	/* current frame */
-	mov.l	@(SF_R15, r1), r3	/* current stack */
-
-	/* switch to proc0's kernel stack */
-	__EXCEPTION_BLOCK(r1, r6)
-	ldc	r0, r7_bank
-	ldc	r2, r6_bank
-	mov	r3, r15
-	__EXCEPTION_UNBLOCK(r0, r1)
-
-	/* safe to call (*exit_func)(p); now */
-	jsr	@r5
-	 nop			/* proc is already in r4 */
-
-	/* proceed to cpu_switch */
-	bra	.L_find_and_switch
-	 mov	#0, r4		/* no "previous" proc */
-
-	.align 2
-.L_switch_exit_proc0_pcb:
-	.long	_C_LABEL(proc0) + P_MD_PCB
-.L_switch_exit_curpcb:
-	.long	_C_LABEL(curpcb)
-
 
 #ifdef SH3
 /*
Index: arch/sh/sh/sh_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/sh/sh/sh_machdep.c,v
retrieving revision 1.16
diff -u -r1.16 sh_machdep.c
--- arch/sh/sh/sh_machdep.c	6 Jun 2007 17:15:12 -0000	1.16
+++ arch/sh/sh/sh_machdep.c	25 Sep 2007 09:53:53 -0000
@@ -716,45 +716,6 @@
 	rval[1] = 0;
 }
 
-void
-setrunqueue(struct proc *p)
-{
-	int whichq = p->p_priority / PPQ;
-	struct prochd *q;
-	struct proc *prev;
-
-#ifdef DIAGNOSTIC
-	if (p->p_back != NULL || p->p_wchan != NULL || p->p_stat != SRUN)
-		panic("setrunqueue");
-#endif
-	q = &qs[whichq];
-	prev = q->ph_rlink;
-	p->p_forw = (struct proc *)q;
-	q->ph_rlink = p;
-	prev->p_forw = p;
-	p->p_back = prev;
-	whichqs |= 1 << whichq;
-}
-
-void
-remrunqueue(struct proc *p)
-{
-	struct proc *prev, *next;
-	int whichq = p->p_priority / PPQ;
-
-#ifdef DIAGNOSTIC
-       if (((whichqs & (1 << whichq)) == 0))
-		panic("remrunqueue: bit %d not set", whichq);
-#endif
-	prev = p->p_back;
-	p->p_back = NULL;
-	next = p->p_forw;
-	prev->p_forw = next;
-	next->p_back = prev;
-	if (prev == next)
-		whichqs &= ~(1 << whichq);
-}
-
 /*
  * Jump to reset vector.
  */
Index: arch/solbourne/solbourne/locore.s
===================================================================
RCS file: /cvs/src/sys/arch/solbourne/solbourne/locore.s,v
retrieving revision 1.8
diff -u -r1.8 locore.s
--- arch/solbourne/solbourne/locore.s	15 Apr 2006 17:36:47 -0000	1.8
+++ arch/solbourne/solbourne/locore.s	25 Sep 2007 09:53:55 -0000
@@ -3233,291 +3233,52 @@
 	.comm	_C_LABEL(masterpaddr), 4
 
 /*
- * Switch statistics (for later tweaking):
- *	nswitchdiff = p1 => p2 (i.e., chose different process)
- *	nswitchexit = number of calls to switchexit()
- *	_cnt.v_swtch = total calls to swtch+swtchexit
+ * cpu_switchto(struct proc *oldproc, struct proc *newproc)
  */
-	.comm	_C_LABEL(nswitchdiff), 4
-	.comm	_C_LABEL(nswitchexit), 4
-
-/*
- * REGISTER USAGE IN cpu_switch AND switchexit:
- * This is split into two phases, more or less
- * `before we locate a new proc' and `after'.
- * Some values are the same in both phases.
- * Note that the %o0-registers are not preserved across
- * the psr change when entering a new process, since this
- * usually changes the CWP field (hence heavy usage of %g's).
- *
- *	%g1 = oldpsr (excluding ipl bits)
- *	%g2 = %hi(_C_LABEL(whichqs)); newpsr
- *	%g3 = p
- *	%g4 = lastproc
- *	%g5 = <free>; newpcb
- *	%g6 = %hi(_C_LABEL(cpcb))
- *	%g7 = %hi(_C_LABEL(curproc))
- *	%o0 = tmp 1
- *	%o1 = tmp 2
- *	%o2 = tmp 3
- *	%o3 = tmp 4; whichqs; vm
- *	%o4 = tmp 4; which; sswap
- *	%o5 = tmp 5; q; <free>
- */
-
-/*
- * switchexit is called only from cpu_exit() before the current process
- * has freed its kernel stack; we must free it.  (curproc is already NULL.)
- *
- * We lay the process to rest by changing to the `idle' kernel stack,
- * and note that the `last loaded process' is nonexistent.
- */
-ENTRY(switchexit)
-	mov	%o0, %g2		! save proc for exit2() call
-
-	/*
-	 * Change pcb to idle u. area, i.e., set %sp to top of stack
-	 * and %psr to PSR_S|PSR_ET, and set cpcb to point to _idle_u.
-	 * Once we have left the old stack, we can call kmem_free to
-	 * destroy it.  Call it any sooner and the register windows
-	 * go bye-bye.
-	 */
-	set	_C_LABEL(idle_u), %g5
-	sethi	%hi(_C_LABEL(cpcb)), %g6
-	mov	1, %g7
-	wr	%g0, PSR_S, %psr	! change to window 0, traps off
-	nop; nop; nop
-	wr	%g0, 2, %wim		! and make window 1 the trap window
-	st	%g5, [%g6 + %lo(_C_LABEL(cpcb))]	! cpcb = &idle_u
-	st	%g7, [%g5 + PCB_WIM]	! idle_u.pcb_wim = log2(2) = 1
-	set	_C_LABEL(idle_u) + USPACE-CCFSZ, %sp	! set new %sp
-#ifdef DEBUG
-	set	_C_LABEL(idle_u), %l6
-	SET_SP_REDZONE(%l6, %l5)
-#endif
-	wr	%g0, PSR_S|PSR_ET, %psr	! and then enable traps
-	call    _C_LABEL(exit2)			! exit2(p)
-	 mov    %g2, %o0
-
-	/*
-	 * Now fall through to `the last switch'.  %g6 was set to
-	 * %hi(_C_LABEL(cpcb)), but may have been clobbered in kmem_free,
-	 * so all the registers described below will be set here.
-	 *
-	 * REGISTER USAGE AT THIS POINT:
-	 *	%g1 = oldpsr (excluding ipl bits)
-	 *	%g2 = %hi(_C_LABEL(whichqs))
-	 *	%g4 = lastproc
-	 *	%g6 = %hi(_C_LABEL(cpcb))
-	 *	%g7 = %hi(_C_LABEL(curproc))
-	 *	%o0 = tmp 1
-	 *	%o1 = tmp 2
-	 *	%o3 = whichqs
-	 */
-
-	INCR(_C_LABEL(nswitchexit))		! nswitchexit++;
-	INCR(_C_LABEL(uvmexp)+V_SWTCH)		! cnt.v_switch++;
-
-	mov	PSR_S|PSR_ET, %g1	! oldpsr = PSR_S | PSR_ET;
-	sethi	%hi(_C_LABEL(whichqs)), %g2
-	clr	%g4			! lastproc = NULL;
+ENTRY(cpu_switchto)
 	sethi	%hi(_C_LABEL(cpcb)), %g6
 	sethi	%hi(_C_LABEL(curproc)), %g7
-	/* FALLTHROUGH */
-
-/*
- * When no processes are on the runq, switch
- * idles here waiting for something to come ready.
- * The registers are set up as noted above.
- */
-	.globl	idle
-idle:
-	st	%g0, [%g7 + %lo(_C_LABEL(curproc))] ! curproc = NULL;
-	wr	%g1, 0, %psr		! (void) spl0();
-1:					! spin reading _whichqs until nonzero
-	ld	[%g2 + %lo(_C_LABEL(whichqs))], %o3
-	tst	%o3
-	bnz,a	Lsw_scan
-	 wr	%g1, IPL_CLOCK << 8, %psr	! (void) splclock();
-	b,a	1b
-
-Lsw_panic_rq:
-	sethi	%hi(1f), %o0
-	call	_C_LABEL(panic)
-	 or	%lo(1f), %o0, %o0
-Lsw_panic_wchan:
-	sethi	%hi(2f), %o0
-	call	_C_LABEL(panic)
-	 or	%lo(2f), %o0, %o0
-Lsw_panic_srun:
-	sethi	%hi(3f), %o0
-	call	_C_LABEL(panic)
-	 or	%lo(3f), %o0, %o0
-1:	.asciz	"switch rq"
-2:	.asciz	"switch wchan"
-3:	.asciz	"switch SRUN"
-	_ALIGN
-
-/*
- * cpu_switch() picks a process to run and runs it, saving the current
- * one away.  On the assumption that (since most workstations are
- * single user machines) the chances are quite good that the new
- * process will turn out to be the current process, we defer saving
- * it here until we have found someone to load.  If that someone
- * is the current process we avoid both store and load.
- *
- * cpu_switch() is always entered at splstatclock or splhigh.
- *
- * IT MIGHT BE WORTH SAVING BEFORE ENTERING idle TO AVOID HAVING TO
- * SAVE LATER WHEN SOMEONE ELSE IS READY ... MUST MEASURE!
- */
-	.globl	_C_LABEL(time)
-ENTRY(cpu_switch)
-	/*
-	 * REGISTER USAGE AT THIS POINT:
-	 *	%g1 = oldpsr (excluding ipl bits)
-	 *	%g2 = %hi(_C_LABEL(whichqs))
-	 *	%g3 = p
-	 *	%g4 = lastproc
-	 *	%g5 = tmp 0
-	 *	%g6 = %hi(_C_LABEL(cpcb))
-	 *	%g7 = %hi(_C_LABEL(curproc))
-	 *	%o0 = tmp 1
-	 *	%o1 = tmp 2
-	 *	%o2 = tmp 3
-	 *	%o3 = tmp 4, then at Lsw_scan, whichqs
-	 *	%o4 = tmp 5, then at Lsw_scan, which
-	 *	%o5 = tmp 6, then at Lsw_scan, q
-	 */
-	sethi	%hi(_C_LABEL(whichqs)), %g2	! set up addr regs
-	sethi	%hi(_C_LABEL(cpcb)), %g6
-	ld	[%g6 + %lo(_C_LABEL(cpcb))], %o0
-	std	%o6, [%o0 + PCB_SP]	! cpcb->pcb_<sp,pc> = <sp,pc>;
+	ld	[%g6 + %lo(_C_LABEL(cpcb))], %o2
+	std	%o6, [%o2 + PCB_SP]	! cpcb->pcb_<sp,pc> = <sp,pc>;
 	rd	%psr, %g1		! oldpsr = %psr;
-	sethi	%hi(_C_LABEL(curproc)), %g7
-	ld	[%g7 + %lo(_C_LABEL(curproc))], %g4	! lastproc = curproc;
-	st	%g1, [%o0 + PCB_PSR]	! cpcb->pcb_psr = oldpsr;
+	st	%g1, [%o2 + PCB_PSR]	! cpcb->pcb_psr = oldpsr;
 	andn	%g1, PSR_PIL, %g1	! oldpsr &= ~PSR_PIL;
 
 	/*
-	 * In all the fiddling we did to get this far, the thing we are
-	 * waiting for might have come ready, so let interrupts in briefly
-	 * before checking for other processes.  Note that we still have
-	 * curproc set---we have to fix this or we can get in trouble with
-	 * the run queues below.
-	 */
-	st	%g0, [%g7 + %lo(_C_LABEL(curproc))]	! curproc = NULL;
-	wr	%g1, 0, %psr			! (void) spl0();
-	nop; nop; nop				! paranoia
-	wr	%g1, IPL_CLOCK << 8 , %psr	! (void) splclock();
-
-Lsw_scan:
-	nop; nop; nop				! paranoia
-	ld	[%g2 + %lo(_C_LABEL(whichqs))], %o3
-
-	/*
-	 * Optimized inline expansion of `which = ffs(whichqs) - 1';
-	 * branches to idle if ffs(whichqs) was 0.
-	 */
-	set	ffstab, %o2
-	andcc	%o3, 0xff, %o1		! byte 0 zero?
-	bz,a	1f			! yes, try byte 1
-	 srl	%o3, 8, %o0
-	b	2f			! ffs = ffstab[byte0]; which = ffs - 1;
-	 ldsb	[%o2 + %o1], %o0
-1:	andcc	%o0, 0xff, %o1		! byte 1 zero?
-	bz,a	1f			! yes, try byte 2
-	 srl	%o0, 8, %o0
-	ldsb	[%o2 + %o1], %o0	! which = ffstab[byte1] + 7;
-	b	3f
-	 add	%o0, 7, %o4
-1:	andcc	%o0, 0xff, %o1		! byte 2 zero?
-	bz,a	1f			! yes, try byte 3
-	 srl	%o0, 8, %o0
-	ldsb	[%o2 + %o1], %o0	! which = ffstab[byte2] + 15;
-	b	3f
-	 add	%o0, 15, %o4
-1:	ldsb	[%o2 + %o0], %o0	! ffs = ffstab[byte3] + 24
-	addcc	%o0, 24, %o0		! (note that ffstab[0] == -24)
-	bz	idle			! if answer was 0, go idle
-	 EMPTY
-2:	sub	%o0, 1, %o4		! which = ffs(whichqs) - 1
-3:	/* end optimized inline expansion */
-
-	/*
-	 * We found a nonempty run queue.  Take its first process.
-	 */
-	set	_C_LABEL(qs), %o5		! q = &qs[which];
-	sll	%o4, 3, %o0
-	add	%o0, %o5, %o5
-	ld	[%o5], %g3		! p = q->ph_link;
-	cmp	%g3, %o5		! if (p == q)
-	be	Lsw_panic_rq		!	panic("switch rq");
-	 EMPTY
-	ld	[%g3], %o0		! tmp0 = p->p_forw;
-	st	%o0, [%o5]		! q->ph_link = tmp0;
-	st	%o5, [%o0 + 4]		! tmp0->p_back = q;
-	cmp	%o0, %o5		! if (tmp0 == q)
-	bne	1f
-	 EMPTY
-	mov	1, %o1			!	whichqs &= ~(1 << which);
-	sll	%o1, %o4, %o1
-	andn	%o3, %o1, %o3
-	st	%o3, [%g2 + %lo(_C_LABEL(whichqs))]
-1:
-	/*
-	 * PHASE TWO: NEW REGISTER USAGE:
+	 * REGISTER USAGE:
 	 *	%g1 = oldpsr (excluding ipl bits)
 	 *	%g2 = newpsr
-	 *	%g3 = p
-	 *	%g4 = lastproc
 	 *	%g5 = newpcb
 	 *	%g6 = %hi(_C_LABEL(cpcb))
 	 *	%g7 = %hi(_C_LABEL(curproc))
-	 *	%o0 = tmp 1
-	 *	%o1 = tmp 2
+	 *	%o0 = oldproc
+	 *	%o1 = newproc
 	 *	%o2 = tmp 3
 	 *	%o3 = vm
 	 *	%o4 = sswap
 	 *	%o5 = <free>
 	 */
 
-	/* firewalls */
-	ld	[%g3 + P_WCHAN], %o0	! if (p->p_wchan)
-	tst	%o0
-	bne	Lsw_panic_wchan		!	panic("switch wchan");
-	 EMPTY
-	ldsb	[%g3 + P_STAT], %o0	! if (p->p_stat != SRUN)
-	cmp	%o0, SRUN
-	bne	Lsw_panic_srun		!	panic("switch SRUN");
-	 EMPTY
-
 	/*
-	 * Committed to running process p.
-	 * It may be the same as the one we were running before.
+	 * Committed to running process p (in o1).
 	 */
+	mov	%o1, %g3
+
 	mov	SONPROC, %o0			! p->p_stat = SONPROC
 	stb	%o0, [%g3 + P_STAT]
 	sethi	%hi(_C_LABEL(want_resched)), %o0
 	st	%g0, [%o0 + %lo(_C_LABEL(want_resched))]	! want_resched = 0;
 	ld	[%g3 + P_ADDR], %g5		! newpcb = p->p_addr;
-	st	%g0, [%g3 + 4]			! p->p_back = NULL;
 	ld	[%g5 + PCB_PSR], %g2		! newpsr = newpcb->pcb_psr;
 	st	%g3, [%g7 + %lo(_C_LABEL(curproc))]	! curproc = p;
 
-	cmp	%g3, %g4		! p == lastproc?
-	be,a	Lsw_sameproc		! yes, go return 0
-	 wr	%g2, 0, %psr		! (after restoring ipl)
-
 	/*
-	 * Not the old process.  Save the old process, if any;
-	 * then load p.
+	 * Save the old process, if any; then load p.
 	 */
-	tst	%g4
+	tst	%o0
 	be,a	Lsw_load		! if no old process, go load
 	 wr	%g1, (IPL_CLOCK << 8) | PSR_ET, %psr
 
-	INCR(_C_LABEL(nswitchdiff))		! clobbers %o0,%o1
 	/*
 	 * save: write back all windows (including the current one).
 	 * XXX	crude; knows nwindows <= 8
@@ -3659,16 +3420,17 @@
 	 */
 
 	retl
-	 EMPTY
-1:
+	 nop
 
-Lsw_sameproc:
-	/*
-	 * We are resuming the process that was running at the
-	 * call to switch().  Just set psr ipl and return.
-	 */
-!	wr	%g2, 0 %psr		! %psr = newpsr; (done earlier)
-	nop
+ENTRY(cpu_idle_enter)
+	retl
+	 nop
+
+ENTRY(cpu_idle_cycle)
+	retl
+	 nop
+
+ENTRY(cpu_idle_leave)
 	retl
 	 nop
 
Index: arch/sparc/conf/files.sparc
===================================================================
RCS file: /cvs/src/sys/arch/sparc/conf/files.sparc,v
retrieving revision 1.78
diff -u -r1.78 files.sparc
--- arch/sparc/conf/files.sparc	29 May 2007 09:54:03 -0000	1.78
+++ arch/sparc/conf/files.sparc	25 Sep 2007 09:53:55 -0000
@@ -291,7 +291,6 @@
 file	arch/sparc/sparc/in_cksum.c		inet
 file	arch/sparc/sparc/intr.c
 file	arch/sparc/sparc/kgdb_machdep.c	kgdb
-file	arch/sparc/sparc/locore2.c
 file	arch/sparc/sparc/machdep.c		!solbourne
 file	arch/sparc/sparc/mem.c			!solbourne
 file	arch/sparc/sparc/mutex.c
